"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
const n9_node_log_1 = require("@neo9/n9-node-log");
const appRootDir = require("app-root-dir");
const path_1 = require("path");
// tslint:disable-next-line:no-import-side-effect
require("reflect-metadata");
const typedi_1 = require("typedi");
const initialise_modules_1 = require("./initialise-modules");
const requestid_1 = require("./requestid");
const routes_1 = require("./routes");
const start_express_app_1 = require("./start-express-app");
/* istanbul ignore next */
function handleThrow(err) {
    throw err;
}
__export(require("./decorators/acl.decorator"));
__export(require("./validators/date-parser.validator"));
function default_1(options) {
    return __awaiter(this, void 0, void 0, function* () {
        // Provides a stack trace for unhandled rejections instead of the default message string.
        process.on('unhandledRejection', handleThrow);
        // Options default
        options = options || {};
        options.path = options.path || path_1.join(appRootDir.get(), 'src', 'modules');
        options.log = options.log || global.log;
        options.hasProxy = (typeof options.hasProxy === 'boolean' ? options.hasProxy : true);
        options.enableRequestId = (typeof options.enableRequestId === 'boolean' ? options.enableRequestId : true);
        // If log if given, add a namespace
        if (options.log) {
            options.log = options.log.module('routing-controller-wrapper');
        }
        else {
            options.log = n9_node_log_1.default('routing-controller-wrapper');
        }
        if (options.enableRequestId) {
            options.log.addFilter(requestid_1.requestIdFilter);
        }
        typedi_1.Container.set("logger", options.log);
        if (global.conf) {
            typedi_1.Container.set("conf", global.conf);
        }
        // Init every modules
        yield initialise_modules_1.default(options.path, options.log);
        const returnObject = yield start_express_app_1.default(options);
        yield routes_1.default(returnObject.app, options);
        return returnObject;
    });
}
exports.default = default_1;
//# sourceMappingURL=index.js.map