/// <reference types="morgan" />
/// <reference types="express" />
/// <reference types="node" />
import { N9Log } from '@neo9/n9-node-log';
import { Express } from 'express';
import { Server } from 'http';
import * as morgan from 'morgan';
import { RoutingControllersOptions } from 'routing-controllers';
export declare namespace RoutingControllerWrapper {
    interface HttpOptions {
        logLevel?: string | false | morgan.FormatFn;
        port?: number | string;
        preventListen?: boolean;
        routingController?: RoutingControllersOptions;
        beforeRoutingControllerLaunchHook?: (app: Express, log: N9Log, options: Options) => Promise<void>;
        afterRoutingControllerLaunchHook?: (app: Express, log: N9Log, options: Options) => Promise<void>;
    }
    interface JWTOptions {
        headerKey?: string;
        secret?: string;
        expiresIn?: number | string;
    }
    interface Options {
        hasProxy?: boolean;
        enableRequestId?: boolean;
        path?: string;
        log?: N9Log;
        http?: HttpOptions;
        jwt?: JWTOptions;
    }
    interface ReturnObject {
        app: Express;
        server: Server;
    }
}
