"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const continuation_local_storage_1 = require("continuation-local-storage");
const shortid = require("shortid");
const requestIdNamespaceName = 'requestIdNamespace';
const requestIdNamespace = continuation_local_storage_1.createNamespace(requestIdNamespaceName);
function requestIdFilter(level, msg, meta) {
    const namespace = continuation_local_storage_1.getNamespace(requestIdNamespaceName);
    return namespace && namespace.get('requestId') ? `(${namespace.get('requestId')}) ${msg}` : msg;
}
exports.requestIdFilter = requestIdFilter;
function setRequestContext(req, res, next) {
    requestIdNamespace.run(() => {
        if (!req.headers.requestId) {
            req.headers.requestId = shortid.generate();
        }
        requestIdNamespace.set('requestId', req.headers.requestId);
        next();
    });
}
exports.setRequestContext = setRequestContext;
//# sourceMappingURL=requestid.js.map