"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const n9_node_utils_1 = require("@neo9/n9-node-utils");
const appRootDir = require("app-root-dir");
const path_1 = require("path");
const RoutesService = require("./routes.service");
function default_1(expressApp, options) {
    return __awaiter(this, void 0, void 0, function* () {
        // Fetch application name
        const name = require(path_1.join(appRootDir.get(), 'package.json')).name;
        expressApp.get('/', (req, res) => {
            res.status(200).send(name);
        });
        // Monitoring route
        expressApp.get('/ping', (req, res) => {
            res.status(200).send('pong');
        });
        expressApp.get('/routes', (req, res) => {
            res.status(200).send(RoutesService.getRoutes());
        });
        // Handle 404 errors
        expressApp.use((req, res, next) => {
            if (!res.headersSent) {
                const err = new n9_node_utils_1.N9Error('not-found', 404, { url: req.url });
                options.log.warn(err);
                let error;
                if (!expressApp.get('env') || ['development', 'test'].indexOf(expressApp.get('env')) !== -1) {
                    error = err;
                }
                return res.status(404).json({
                    code: err.message,
                    status: err.status,
                    context: err.context,
                    error
                });
            }
        });
    });
}
exports.default = default_1;
//# sourceMappingURL=routes.js.map