"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const routing_controllers_1 = require("routing-controllers");
const aclDescriptions = [];
function addRoute(object, methodName, perms, loadPath) {
    aclDescriptions.push({
        object,
        methodName,
        perms,
        loadPath
    });
}
exports.addRoute = addRoute;
function getRoutes() {
    const ret = aclDescriptions.map((d) => {
        const act = routing_controllers_1.getMetadataArgsStorage().actions.filter((action) => {
            return action.target === d.object.constructor && action.method === d.methodName;
        })[0];
        const controller = routing_controllers_1.getMetadataArgsStorage().controllers.filter((ctrl) => {
            return ctrl.target === d.object.constructor;
        });
        let controllerRoutePrefix = '';
        if (controller && controller[0] && controller[0].route) {
            controllerRoutePrefix = controller[0].route;
        }
        let actRoute = '';
        if (act.route) {
            actRoute = act.route.toString();
        }
        return {
            method: act.type,
            path: controllerRoutePrefix + actRoute,
            acl: {
                perms: d.perms,
                loadPath: d.loadPath
            }
        };
    });
    return ret;
}
exports.getRoutes = getRoutes;
//# sourceMappingURL=routes.service.js.map