"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const class_validator_1 = require("class-validator");
const moment = require("moment");
// TODO : consider sample https://github.com/typestack/class-transformer/tree/master/sample/sample5-custom-transformer
function DateParser(dateFormat, validationOptions) {
    return (object, propertyName) => {
        class_validator_1.registerDecorator({
            name: "DateParser",
            target: object.constructor,
            propertyName,
            constraints: [dateFormat],
            options: validationOptions,
            validator: {
                validate(value, args) {
                    const [dateFormat2] = args.constraints;
                    args.object[propertyName] = moment(value, dateFormat2).toDate();
                    return true;
                }
            }
        });
    };
}
exports.DateParser = DateParser;
//# sourceMappingURL=date-parser.validator.js.map